import { createCopyToClipboardPlugin } from './plugins/copy-to-clipboard.js';
import { createLineNumberPlugin } from './plugins/line-numbers.js';
import { createToolbarPlugin } from './plugins/toolbar.js';
export function createPluginApplier(plugins) {
    const context = {
        toolbar: {
            buttons: [],
        },
    };
    const appliers = plugins
        // uniq
        .filter((item, index, arr) => arr.indexOf(item, 0) === index)
        .map((plugin) => {
        if (plugin === 'line-numbers')
            return createLineNumberPlugin();
        if (plugin === 'toolbar')
            return createToolbarPlugin(context);
        if (plugin === 'copy-to-clipboard')
            return createCopyToClipboardPlugin(context);
    });
    return (options) => {
        for (const applier of appliers) {
            applier && applier(options);
        }
    };
}
