import 'prismjs';
import { visit } from 'unist-util-visit';
import { internalPlugins } from './constant.js';
import { createParseCodeVisitor } from './create-parse-code-vistor.js';
import { createPreElementSelector } from './create-pre-element-selector.js';
const rehypePrism = (options) => {
    if (options && options.plugins) {
        const plugins = options.plugins
            .filter((plugin) => !internalPlugins.includes(plugin));
        for (const plugin of plugins) {
            import(`prismjs/plugins/${plugin}/prism-${plugin}.js`);
        }
    }
    return (tree) => visit(tree, createPreElementSelector(), createParseCodeVisitor(options));
};
export default rehypePrism;
