import { h } from 'hastscript';
import { appendClassName } from "../utils/append-class-name.js";
import { selectCodeElement } from "../utils/select-code-element.js";
function getLineNumber(str) {
    const match = str.match(/\n(?!$)/g);
    return match ? match.length + 1 : 1;
}
export function createLineNumberPlugin() {
    return (options) => {
        const { preElement, raw } = options;
        const codeElement = selectCodeElement(preElement);
        if (!codeElement)
            return;
        appendClassName(preElement, 'line-numbers');
        const lineNumber = getLineNumber(raw);
        const lineNumberColumn = h('span', {
            'aria-hidden': 'true',
            className: ['line-numbers-rows'],
        }, new Array(lineNumber).fill(h('span')));
        codeElement.children.push(lineNumberColumn);
    };
}
